<template>
  <div class="card">
    <div class="card-body p-0" style="display: block;">
      <table class="table table-striped projects">
        <thead>
        <tr>
          <th style="width: 1%"></th>
          <th style="width: 15%">Название модели</th>
          <th style="width: 40%">Стоковое изображение</th>
        </tr>
        </thead>
        <tbody @change="createModel" v-for="item in category">
        <tr>
          <td>1</td>
          <td>
            <input type="text"
                   class="form-control"
                   name="category_name"
                   placeholder="Добавить модель"
                   v-model="nameModel"
            >
          </td>
          <td>
            <ul class="list-inline d-flex align-items-center">
              <li v-if="nameModel" class="list-inline-item">
                <div class="btn btn-outline-primary position-relative" style="width: 150px; height: 36px;">
                  <span>Добавить  image</span>
                  <input type="file" accept="image/*" @change="addFile()" multiple>
                </div>
                <div v-if="noImage" class="btn btn-outline-primary position-relative"
                     style="width: 150px; height: 36px;">
                  <span @click="createModel()">Без image</span>
                </div>
              </li>
            </ul>
          </td>
        </tr>
        </tbody>
      </table>
    </div>
    <!-- /.card-body -->
  </div>
</template>

<script>
export default {
  name: "UpdateCategoryItemComponent",
  props:{category: Object},
  data() {
    return {
      nameModel: '',
      imageModel: '',
      noImage: true,
      liItems: 0
    }
  },
  methods: {
    addFile() {
      this.imageModel = event.target.files[0];
    },
    getImage($eventTarget, $imagePath) {
      var list = $eventTarget.closest('.list-inline');
      var li = document.createElement("li");
      var img = document.createElement("img");
      Object.assign(img, {
        categoryName: 'fas fa-trash',
        color: 'red',
        src: $imagePath,
        alt: 'bike',
        width: 120
      });
      Object.assign(li, {
        categoryName: 'list-inline-item position-relative',
      });
      list.append(li);
      li.append(img);
      img.onclick = () => {
        let eventTarget = event.target;
        axios.post('/api/admin/category/image-delete', {
          'model_image_src': eventTarget
        })
            .then(eventTarget.closest('li').remove())
            .then(this.liItems --)
            .then(this.showNoImage())
      };
    },
    createModel() {
      let eventTarget = event.target;
      let data = new FormData();
      data.append('category_name', this.nameCategory);
      data.append('category_status', Number(this.statusCategory));
      data.append('model_name', this.nameModel);
      if (this.imageModel) {
        data.append('model_image', this.imageModel, this.imageModel.name);
      }
      axios.post('/api/admin/category', data)
          .then(res => {
            this.getImage(eventTarget, res.data.image)
            this.noImage = false;
          })
          .then(this.liItems ++)
          .then(this.showNoImage())
      // this.imageModel = event.target.files[0]['name']
      // this.$emit("response", {data: [this.nameModel, this.imageModel]});
    },
    showNoImage(){
      if(this.liItems == 1){
        this.noImage = true;
        this.imageModel = null;
      }
    }
  }
}
</script>

<style scoped>
input[type='file'] {
  opacity: 0;
  position: absolute;
  left: 0;
  top: 0;
  width: 150px;
}
</style>